from javax.imageio import ImageIO
from java.io import File
from nodebox.graphics import Point
from math import sqrt
import os
from os.path import abspath

def pixel(c,c1,c2,edge):
    r,g,b = c[0],c[1],c[2]
    r1,g1,b1 = c1[0],c1[1],c1[2]
    r2,g2,b2 = c2[0],c2[1],c2[2]
    if (sqrt((r-r1)*(r-r1)+(g-g1)*(g-g1)+(b-b1)*(b-b1))>= edge) or (sqrt((r-r2)*(r-r2)+(g-g2)*(g-g2)+(b-b2)*(b-b2))>= edge):
        return True
    else:
        return False


def cook(foto, sens,sg):
    f = File(abspath(foto))
    bi = ImageIO.read(f)
    raster = bi.raster
    w = raster.width
    h = raster.height
    seg = sg
    all = []
    for i in xrange(0,w,seg):
        for j in xrange(0,h,seg):
            c = bi.raster.getPixel(i,j,[0.0,0.0,0.0])
            try:
                c1 = bi.raster.getPixel(i+1,j,[0.0,0.0,0.0])
                c2 = bi.raster.getPixel(i,j+1,[0.0,0.0,0.0])
            except:
                pass
            if pixel(c,c1,c2,sens):
                all.append(Point(i,j))
    return all
